<?php
/**
 * A general opening time class
 *
 * @author		Roland Haeder <webmaster@ship-simu.org>
 * @version		0.0.0
 * @copyright	Copyright (c) 2007, 2008 Roland Haeder, 2009 Ship-Simu Developer Team
 * @license		GNU GPL 3.0 or any newer version
 * @link		http://www.ship-simu.org
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
abstract class BaseOpening extends BaseFrameworkSystem {
	/**
	 * A bank instance
	 */
	private $bankInstance = null;

	/**
	 * Protected constructor
	 *
	 * @param	$className	The class' real name
	 * @return	void
	 */
	protected function __construct ($className) {
		// Call parent constructor
		parent::__construct($className);
	}

	/**
	 * Setter for bank instance
	 *
	 * @param	$bankInstance	An instance of a bank
	 * @return	void
	 */
	protected final function setBankInstance (BaseBank $bankInstance) {
		$this->bankInstance = $bankInstance;
	}

	/**
	 * Checks wether we are within the opening times
	 *
	 * @return	$withinOpeningTimes		Wether we are within opening times
	 */
	public abstract function ifWithinOpeningTimes ();
}

// [EOF]
?>
